#! @BASH@
#
echo 1..8 # Number of tests to be executed.
#
test -n "$CDO"      || CDO="@abs_top_builddir@/src/cdo $CDO_DEBUG"
test -n "$DATAPATH" || DATAPATH="@abs_top_srcdir@/test/data/"
#
HAS_THREADS=`${CDO} --config has-threads`
#
ABSLIMMAX=0.0001
ABSLIMDIS=0.001
#
FORMAT="-f srv -b 32"
GRID=global_5
#
IFILE=$DATAPATH/topo_eu5.grb
NTEST=1
#
OPERATORS="remapdis remapnn remapbil remapbic remapcon remapcon2 remapscon remaplaf"
for RMOD in $OPERATORS; do
    if [ -z "$1" ] || [ $NTEST == $1 ]; then
        if [ "${HAS_THREADS}" = yes ] ; then
            ABSLIM=$ABSLIMMAX
            if [ $RMOD = dis ];  then ABSLIM=$ABSLIMDIS; fi
            CDOTEST="${RMOD} regional"
            RSTAT=0
            # for extra in def off on; do
            for extra in off; do
                EXTRA="$extra"
                if [ "$EXTRA" = "def" ]; then EXTRA=""; fi

                OFILE=topo_eu5_${RMOD:5}_${extra}$$
                RFILE=$DATAPATH/topo_eu5_${RMOD:5}_${extra}_ref

                for GRIDTYPE in regular curvilinear; do
                    SETGRID=""
                    if [ "$GRIDTYPE" != "regular" ]; then SETGRID="-setgridtype,$GRIDTYPE"; fi

                    CDOCOMMAND="$CDO  $FORMAT ${RMOD},$GRID  $SETGRID  $IFILE ${OFILE}"

                    echo "Running test: $NTEST"
                    echo "$CDOCOMMAND"

                    REMAP_EXTRAPOLATE=$EXTRA $CDOCOMMAND
                    test $? -eq 0 || (( RSTAT+=1 ))

                    $CDO  diff,abslim=$ABSLIM $OFILE $RFILE
                    test $? -eq 0 || (( RSTAT+=1 ))

                    rm -f $OFILE
                done
            done

            test $RSTAT -eq 0 && echo "ok $NTEST - $CDOTEST"
            if [ $RMOD = dis ]; then
                test $RSTAT -eq 0 || echo "not ok $NTEST - $CDOTEST # TODO check depends on optimization"
            else
                test $RSTAT -eq 0 || echo "not ok $NTEST - $CDOTEST"
            fi

            rm -f $OFILE
        else
            echo "ok $NTEST - $CDOTEST # SKIP POSIX threads not enabled"
        fi
    fi
    (( NTEST+=1 ))
done
#
exit 0
